<!DOCTYPE html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1">
		<title>Bootstrap-Flex</title>

		<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css" integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">

	</head>

	<body>
		<div class="container-fluid text-center">
			<h1>Bootstrap Flex</h1>
			<p>Use the d-flex class to create a flex container and transform direct children into flex items.</p>
			<!-- align-items-center - class will vertically center all the child elements. It will only work if the div or container is in flex -->
			<!-- justify-content-center -it will horizontally center all the child elements. It will only be accessible if the display value is flex. -->
			<!-- d-flex - the flex value will change the element into block-level container. It will make all the elements become flexible that allows them to occupy space enough for the content of an element and at the samte time will have the elements appear beside each other. (flex-rows/flex-column) -->

			<h2>Flex Column</h2>
			<div style="height:500px" class="bg-dark d-flex flex-column p-3 align-items-center justify-content-center">
				<div class="p-3 bg-success col-2">Flex Item A</div>
				<div class="p-3 bg-warning col-2">Flex Item B</div>
				<div class="p-3 bg-danger col-2">Flex Item C</div>
			</div>

			<h2>Flex Row</h2>
			<div class="bg-dark p-3 d-flex flex-row justify-content-center">
				<div class="p-3 bg-success">Flex Item A</div>
				<div class="p-3 bg-warning">Flex Item B</div>
				<div class="p-3 bg-danger">Flex Item C</div>
			</div>

			<h2>Flex Row Reverse</h2>
			<div class="bg-dark p-3 d-flex flex-row-reverse">
				<div class="p-3 bg-success">Flex Item A</div>
				<div class="p-3 bg-warning">Flex Item B</div>
				<div class="p-3 bg-danger">Flex Item C</div>
			</div>

			<h2>Create space between elements</h2>
			<div class="bg-dark p-3 d-md-flex flex-row justify-content-around">
				<div class="p-3 bg-success">Flex Item A</div>
				<div class="p-3 bg-warning">Flex Item B</div>
				<div class="p-3 bg-danger">Flex Item C</div>
			</div>

			<h2>Flexbox with margin</h2>
			<div class="bg-dark p-3 d-flex flex-row">
				<div class="p-3 bg-success">Flex Item A</div>
				<div class="p-3 bg-warning">Flex Item B</div>
				<div class="p-3 bg-danger ml-auto">Flex Item C</div>
				<div class="p-3 bg-primary">Flex Item D</div>
			</div>

			<h2>Nested Flex Elements</h2>
			<div class="bg-dark p-3 d-flex flex-row">
				<div class="p-3 bg-success mr-auto">Flex Item A</div>
				<div class="d-flex flex justify-content-between w-50">
					<div class="p-3 bg-warning">Flex Item B</div>
					<div class="p-3 bg-danger">Flex Item C</div>
					<div class="p-3 bg-primary">Flex Item D</div>
				</div>
			</div>
			
		</div>

		<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
		<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct" crossorigin="anonymous"></script>
	</body>
</html>